/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mq;

import java.io.IOException;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;

/**
 *
 * @author gaurav
 */
class MyCallbackHandler implements CallbackHandler {

    /**
   * Username which will be set in the NameCallback, when NameCallback is handled
   */
  private String username;

  /**
   * Password which will be set in the PasswordCallback, when PasswordCallback is handled
   */
  private String password;

  /**
   * Constructor
   * @param username The username
   * @param password The password
   */
  public MyCallbackHandler(String username, String password) {
   this.username = username;
   this.password = password;
  }

  /**
   * @param callbacks Instances of Callbacks
   * @throws IOException IOException
   * @throws UnsupportedCallbackException If Callback is other than NameCallback or PasswordCallback
   */
  public void handle(Callback callbacks[]) throws IOException, UnsupportedCallbackException {
        System.out.println("in handle of callback handler -------");
   for(int i = 0; i < callbacks.length; i++) {

       if(callbacks[i] instanceof NameCallback) {
    NameCallback nc = (NameCallback)callbacks[i];
    System.out.println("value of Name callback : "+ nc.getName() +
                   " & prompt is " + nc.getPrompt());
    nc.setName(username);
       } else if(callbacks[i] instanceof PasswordCallback) {
    PasswordCallback pc = (PasswordCallback)callbacks[i];
    System.out.println("value of Pwd callback : "+ pc.toString() +
                   " & prompt is " + pc.getPrompt());
    pc.setPassword(password.toCharArray());
       } else {
    throw new UnsupportedCallbackException(callbacks[i], "Unrecognized Callback");
       }

   }
  }

  /**
     * Clears out password state.
     */
    public void clearPassword() {
        if (password != null) {
            for (int i = 0; i < password.length(); i++)
                password = "";
            password = null;
        }
    }
}

